return function(button_list)
	local ret= {}
	local rots= {Left= 90, Down= 0, Up= 180, Right= 270}
	for i, button in ipairs(button_list) do
		ret[i]= Def.Sprite{
			Texture= "tap_explosion 3x2.png", InitCommand= function(self)
				self:rotationz(rots[button]):draworder(newfield_draw_order.explosion)
					:animate(false):diffusealpha(0)
			end,
			ColumnJudgmentCommand= function(self, param)
				local judge_frames= {
					TapNoteScore_W1= 5,
					TapNoteScore_W2= 4,
					TapNoteScore_W3= 3,
					TapNoteScore_W4= 2,
					TapNoteScore_W5= 1,
					TapNoteScore_Miss= 0,
					HoldNoteScore_Held= 4,
				}
				local exp_frame= judge_frames[param.tap_note_score or param.hold_note_score]
				if exp_frame then
					self:stoptweening():setstate(exp_frame):stopeffect()
						:diffusealpha(1.2):zoom(1.1):accelerate(0.15):zoom(1.0)
						:diffusealpha(0)
					if param.tap_note_score == "TapNoteScore_W1" then
						self:glowshift():effectperiod(0.05):effectcolor1{1,1,1,0}
							:effectcolor2{1,1,1,0.5}
					end
				end
			end,
		}
	end
	return ret
end
