local skin_name= Var("skin_name")
return function(button_list)
	local rots= {Left= 90, Down= 0, Up= 180, Right= 270}
	local parts_per_beat= 48
	local tap_texture_map= {
		parts_per_beat= parts_per_beat, quanta= {
			{per_beat= 1, trans_x= 0, trans_y= 0},
			{per_beat= 2, trans_x= .125, trans_y= 0},
			{per_beat= 3, trans_x= .25, trans_y= 0},
			{per_beat= 4, trans_x= .375, trans_y= 0},
			{per_beat= 6, trans_x= .5, trans_y= 0},
			{per_beat= 8, trans_x= .625, trans_y= 0},
			{per_beat= 12, trans_x= .75, trans_y= 0},
			{per_beat= 16, trans_x= .875, trans_y= 0},
		},
	}
	local lift_texture_map= {
		parts_per_beat= parts_per_beat, quanta= {
			{per_beat= 1, trans_x= 0, trans_y= 0},
			{per_beat= 2, trans_x= .125, trans_y= 0},
			{per_beat= 3, trans_x= .25, trans_y= 0},
			{per_beat= 4, trans_x= .375, trans_y= 0},
			{per_beat= 6, trans_x= .5, trans_y= 0},
			{per_beat= 8, trans_x= .625, trans_y= 0},
			{per_beat= 12, trans_x= .75, trans_y= 0},
			{per_beat= 16, trans_x= .875, trans_y= 0},
		},
	}
	local mine_texture_map= {
		parts_per_beat= parts_per_beat,
		quanta= {{per_beat= 1, trans_x= 0, trans_y= 0}}
	}
	local hold_state_map= NewSkin.single_quanta_state_map{1}
	local inactive_hold_state_map= NewSkin.single_quanta_state_map{2}
	local roll_state_map= NewSkin.single_quanta_state_map{1, 2, 3, 4}
	local inactive_roll_state_map= NewSkin.single_quanta_state_map{5}
	local columns= {}
	for i, button in ipairs(button_list) do
		columns[i]= {
			taps= {
				NewSkinTapPart_Tap= {
					texture_map= tap_texture_map,
					actor= Def.Model{
						InitCommand= function(self) self:rotationz(rots[button]) end,
						Meshes= NEWSKIN:get_path(skin_name, "tap_model"),
						Materials= NEWSKIN:get_path(skin_name, "tap_model"),
						Bones= NEWSKIN:get_path(skin_name, "tap_model"),
					},
				},
				NewSkinTapPart_Mine= {
					texture_map= mine_texture_map,
					actor= Def.Model{
						InitCommand= function(self)
							self:effectclock("beat")
						end,
						Meshes= NEWSKIN:get_path(skin_name, "mine_model.txt"),
						Materials= NEWSKIN:get_path(skin_name, "mine_model.txt"),
						Bones= NEWSKIN:get_path(skin_name, "mine_model.txt"),
					},
				},
				NewSkinTapPart_Lift= {
					texture_map= lift_texture_map,
					actor= Def.Model{
						InitCommand= function(self) self:rotationz(rots[button]) end,
						Meshes= NEWSKIN:get_path(skin_name, "tap_model"),
						Materials= NEWSKIN:get_path(skin_name, "tap_model"),
						Bones= NEWSKIN:get_path(skin_name, "tap_model"),
					},
				},
			},
			holds= {
				TapNoteSubType_Hold= {
					{
						state_map= inactive_hold_state_map,
						textures= {"hold_body 2x1.png"},
						length_data= {
							body_pixs= 256,
						},
					},
					{
						state_map= hold_state_map,
						textures= {"hold_body 2x1.png"},
						length_data= {
							body_pixs= 256,
						},
					},
				},
				TapNoteSubType_Roll= {
					{
						state_map= inactive_roll_state_map,
						textures= {"roll_body 5x1.png"},
						length_data= {
							body_pixs= 256,
						},
					},
					{
						state_map= roll_state_map,
						textures= {"roll_body 5x1.png"},
						length_data= {
							body_pixs= 256,
						},
					},
				},
			},
			reverse_holds= {
				TapNoteSubType_Hold= {
					{
						state_map= inactive_hold_state_map,
						textures= {"hold_body 2x1.png"},
						flip= "TexCoordFlipMode_Y",
						length_data= {
							body_pixs= 256,
						},
					},
					{
						state_map= hold_state_map,
						textures= {"hold_body 2x1.png"},
						flip= "TexCoordFlipMode_Y",
						length_data= {
							body_pixs= 256,
						},
					},
				},
				TapNoteSubType_Roll= {
					{
						state_map= inactive_roll_state_map,
						textures= {"roll_body 5x1.png"},
						flip= "TexCoordFlipMode_Y",
						length_data= {
							body_pixs= 256,
						},
					},
					{
						state_map= roll_state_map,
						textures= {"roll_body 5x1.png"},
						flip= "TexCoordFlipMode_Y",
						length_data= {
							body_pixs= 256,
						},
					},
				},
			},
		}
	end
	return {columns= columns}
end
